## gcc-riscv64-unknown-elf 19

=== gcc/testsuite/go.test/test/bench/garbage/Makefile ===
# Copyright 2010 The Go Authors. All rights reserved.
# Use of this source code is governed by a BSD-style
# license that can be found in the LICENSE file.

ALL=\
	parser\
	peano\
	tree\
	tree2\

all: $(ALL)

%: %.go
	go build $*.go stats.go

%.bench: %
	time ./$*

bench: $(addsuffix .bench, $(ALL))

clean:
	rm -f $(ALL)

## gcc-riscv64-unknown-elf 8.2.0.2019.08+dfsg~rc1

=== debian/changelog ===
gcc-riscv64-unknown-elf (8.2.0.2019.08+dfsg~rc1-1) unstable; urgency=low

  * Initial packaging

 -- Keith Packard <keith.packard@sifive.com>  Thu, 15 Aug 2019 23:20:51 -0700

=== debian/control ===
Source: gcc-riscv64-unknown-elf
Section: devel
Priority: optional
Maintainer: Keith Packard <keith.packard@sifive.com>
Build-Depends: debhelper (>= 10.0.0), m4, libtool,
        zlib1g-dev, gawk, lzma, xz-utils, patchutils,
	bison, flex, gettext, texinfo, locales, sharutils,
	libmpfr-dev, libmpc-dev, libgmp-dev,
	dejagnu, autogen, lsb-release,
	binutils-riscv64-unknown-elf, quilt
Standards-Version: 4.4.0
Homepage: https://github.com/riscv/riscv-gcc
Vcs-Git: https://salsa.debian.org/debian/gcc-riscv64-unknown-elf.git
Vcs-Browser: https://salsa.debian.org/debian/gcc-riscv64-unknown-elf
X-Python-Version: >= 2.7

Package: gcc-riscv64-unknown-elf
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, binutils-riscv64-unknown-elf
Description: GCC compiler for embedded RISC-V chips
 Bare metal compiler for embedded RISC-V chips supporting both 64 and
 32 bit architectures. This package includes patches for
 vendor-specific ISA extensions.

## gcc-riscv64-unknown-elf 8.3.0.2019.08+dfsg

=== debian/changelog ===
gcc-riscv64-unknown-elf (8.3.0.2019.08+dfsg-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:14:45 +0100

gcc-riscv64-unknown-elf (8.3.0.2019.08+dfsg-1) unstable; urgency=medium

  * Move to GCC 8.3.0
  * Remove non-DFSG documentation
  * Add in a few SiFive patches

 -- Keith Packard <keithp@keithp.com>  Tue, 01 Oct 2019 18:26:31 -0700

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,13 @@
 Section: devel
 Priority: optional
 Maintainer: Keith Packard <keith.packard@sifive.com>
-Build-Depends: debhelper (>= 10.0.0), m4, libtool,
+Build-Depends: debhelper (>= 11.0.0), m4, libtool,
         zlib1g-dev, gawk, lzma, xz-utils, patchutils,
 	bison, flex, gettext, texinfo, locales, sharutils,
 	libmpfr-dev, libmpc-dev, libgmp-dev,
 	dejagnu, autogen, lsb-release,
 	binutils-riscv64-unknown-elf, quilt
-Standards-Version: 4.4.0
+Standards-Version: 4.4.1
 Homepage: https://github.com/riscv/riscv-gcc
 Vcs-Git: https://salsa.debian.org/debian/gcc-riscv64-unknown-elf.git
 Vcs-Browser: https://salsa.debian.org/debian/gcc-riscv64-unknown-elf

## gcc-riscv64-unknown-elf 9.3.0

=== debian/changelog ===
gcc-riscv64-unknown-elf (9.3.0-0ubuntu1) focal; urgency=medium

  * Build using GCC 9.3.0.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 02 Apr 2020 11:41:26 +0200

## gcc-riscv64-unknown-elf 10.2.0

=== debian/changelog ===
gcc-riscv64-unknown-elf (10.2.0-0ubuntu1) groovy; urgency=medium

  * Build using GCC 10.2.0.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 27 Sep 2020 16:50:06 +0200

## gcc-riscv64-unknown-elf 11

=== debian/changelog ===
gcc-riscv64-unknown-elf (11) unstable; urgency=medium

  * Switch to Debian gcc sources
  * Use /bin paths for host tools. Closes: #1000964.

 -- Keith Packard <keithp@keithp.com>  Mon, 08 Aug 2022 21:07:41 -0700

=== debian/control ===
Source: gcc-riscv64-unknown-elf
Section: devel
Priority: optional
Maintainer: Keith Packard <keithp@keithp.com>
Build-Depends:
 autoconf2.69,
 binutils-riscv64-unknown-elf (>= 2.38.90),
 bison,
 debhelper (>= 10),
 dejagnu,
 flex,
 gawk,
 gcc-12-source,
 gettext,
 libgmp-dev,
 libmpc-dev,
 libmpfr-dev,
 libtool,
 locales,
 lsb-release,
 lzma,
 m4,
 patchutils,
 sharutils,
 texinfo,
 xz-utils,
 zlib1g-dev,
 libisl-dev
Standards-Version: 4.2.0
Rules-Requires-Root: no
Homepage: http://gcc.gnu.org/
Vcs-Git: https://salsa.debian.org/debian/gcc-riscv64-unknown-elf.git
Vcs-Browser: https://salsa.debian.org/debian/gcc-riscv64-unknown-elf

Package: gcc-riscv64-unknown-elf
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, binutils-riscv64-unknown-elf (>= 2.38.90)
Built-Using: ${Built-Using}
Description: GCC cross compiler for Risc-V processors
 Bare metal compiler for embedded Risc-V chips, both 32-bit and 64-bit

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk

target=riscv64-unknown-elf

GCC_VERSION=12
GCC_PACKAGE=gcc-$(GCC_VERSION)

DEB_SOURCE_VERSION=$(shell dpkg-parsechangelog -S Version)

package=gcc-riscv64-unknown-elf
top_dir=$(shell pwd)
gcc_dir=/usr/src/$(GCC_PACKAGE)
doc_dir=/usr/share/doc/$(package)
build_doc_dir=$(top_dir)/debian/$(package)$(doc_dir)
stampdir=debian/stamp

source_version := $(shell dpkg-query -W -f="\$${Version}\n" $(GCC_PACKAGE)-source)
deb_version := $(source_version)+$(DEB_SOURCE_VERSION)
deb_upstream_version := $(shell echo $(deb_version) | cut -d- -f1)
base_version := $(shell echo $(deb_version) | sed -e 's/\([1-9]\.[0-9]\).*-.*/\1/')
BUILT_USING := $(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W $(GCC_PACKAGE)-source)

upstream_dir=gcc-$(deb_upstream_version)

unpack_stamp=$(stampdir)/unpack
tar_stamp=$(stampdir)/tar

src_dir=$(upstream_dir)
build_dir=build

export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-format
build_flags:=$(shell dpkg-buildflags --export=configure) INHIBIT_LIBC_CFLAGS="-DUSE_TM_CLONE_REGISTRY=0"

target_tools=\
	AR_FOR_TARGET=$(target)-ar \
	AS_FOR_TARGET=$(target)-as \
	LD_FOR_TARGET=$(target)-ld \
	NM_FOR_TARGET=$(target)-nm \
	OBJDUMP_FOR_TARGET=$(target)-objdump \
	RANLIB_FOR_TARGET=$(target)-ranlib \
	READELF_FOR_TARGET=$(target)-readelf \
	STRIP_FOR_TARGET=$(target)-strip

host_tools=\
        SED=/bin/sed \
        SHELL=/bin/sh \
        BASH=/bin/bash \
        CONFIG_SHELL=/bin/bash


configure_flags = \
	--enable-languages=c,c++ \
	--prefix=/usr/lib \
	--infodir=/usr/share/doc/$(package)/info \
	--mandir=/usr/share/man \
	--htmldir=/usr/share/doc/$(package)/html \
	--pdfdir=/usr/share/doc/$(package)/pdf \
	--bindir=/usr/bin \
	--libexecdir=/usr/lib \
	--libdir=/usr/lib \
	--with-system-zlib \
	--enable-multilib \
	--disable-decimal-float \
	--disable-libffi \
	--disable-libgomp \
	--disable-libmudflap \
	--disable-libquadmath \
	--disable-libssp \
	--disable-libstdcxx-pch \
	--disable-libstdc++-v3 \
	--disable-nls \
	--disable-shared \
	--disable-threads \
	--with-arch=rv64imafdc \
	--enable-tls \
	--build=$(DEB_BUILD_GNU_TYPE) \
	--host=$(DEB_HOST_GNU_TYPE) \
	--target=$(target) \
	--with-gnu-as \
	--with-gnu-ld \
	--with-headers=no \
	--without-newlib \
	"--with-pkgversion=$(deb_version)" \
	--without-included-gettext \
	$(host_tools) \
	$(target_tools) \
	$(build_flags) \
	CFLAGS_FOR_TARGET='-Os -mcmodel=medany' CXXFLAGS_FOR_TARGET='-Os -mcmodel=medany'

%:
	dh $@ -D$(src_dir) -B$(build_dir)

$(unpack_stamp): $(tar_stamp)
	set -ex; \
		cd gcc-*; \
		for patch in ../debian/patches/*.patch; do \
			echo Applying patch "$$patch"; \
			patch -p1 < "$$patch"; \
		done
	touch $@

$(tar_stamp):
	tar xf $(gcc_dir)/gcc-*.tar.*
	mkdir -p $(stampdir)
	cp /usr/share/doc/$(GCC_PACKAGE)-source/copyright debian/copyright-gcc
	touch $@

override_dh_autoreconf: $(unpack_stamp)
	autoreconf2.69 -f -i $(upstream_dir)

override_dh_auto_configure: $(unpack_stamp)
	mkdir -p $(build_dir)
	dh_auto_configure -D$(src_dir) -B$(build_dir) -- $(configure_flags)

override_dh_auto_clean:
	rm -rf $(upstream_dir) $(build_dir) debian/tmp debian/copyright-gcc $(stampdir)
	dh_autoreconf_clean

override_dh_auto_test:
	@echo "no testing, that's way too painful"
#	dh_auto_test -D$(src_dir) -B$(build_dir) --max-parallel=1

override_dh_gencontrol:
	dh_gencontrol -a -- -v$(deb_version) -Vlocal:Version=$(deb_upstream_version) -Vgcc:Version=$(source_version) -VBuilt-Using="$(BUILT_USING)"

override_dh_auto_install:
	mkdir -p $(top_dir)/debian/tmp
	cd build && make install DESTDIR=$(top_dir)/debian/tmp

override_dh_installchangelogs:
	dh_installchangelogs $(upstream_dir)/ChangeLog

override_dh_compress:
	dh_compress -Xexamples/

override_dh_strip:
	dh_strip -X.a

## gcc-riscv64-unknown-elf 12

=== debian/changelog ===
gcc-riscv64-unknown-elf (12) unstable; urgency=medium

  * Update to gcc 13

 -- Keith Packard <keithp@keithp.com>  Thu, 18 Jan 2024 12:29:40 -0800

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
  dejagnu,
  flex,
  gawk,
- gcc-12-source,
+ gcc-13-source,
  gettext,
  libgmp-dev,
  libmpc-dev,

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 target=riscv64-unknown-elf
 
-GCC_VERSION=12
+GCC_VERSION=13
 GCC_PACKAGE=gcc-$(GCC_VERSION)
 
 DEB_SOURCE_VERSION=$(shell dpkg-parsechangelog -S Version)

## gcc-riscv64-unknown-elf 16

=== debian/changelog ===
gcc-riscv64-unknown-elf (16) unstable; urgency=medium

  * Fix broken upload

 -- Keith Packard <keithp@keithp.com>  Sun, 01 Dec 2024 09:58:05 -0800

gcc-riscv64-unknown-elf (15) unstable; urgency=medium

  * Add -mxgot to mips64el build
  * Un-limit binary architecture. Closes: #1087676.

 -- Keith Packard <keithp@keithp.com>  Wed, 27 Nov 2024 18:58:23 -0800

gcc-riscv64-unknown-elf (14) unstable; urgency=medium

  * Limit binary architectures to avoid broken linkers. Closes: #1086462.

 -- Keith Packard <keithp@keithp.com>  Thu, 07 Nov 2024 22:40:18 -0800

gcc-riscv64-unknown-elf (13) unstable; urgency=medium

  * Add patch to preserve NaN fraction and sign

  * Update to gcc 14

 -- Keith Packard <keithp@keithp.com>  Sat, 28 Sep 2024 11:12:00 -0700

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
  dejagnu,
  flex,
  gawk,
- gcc-13-source,
+ gcc-14-source,
  gettext,
  libgmp-dev,
  libmpc-dev,

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 target=riscv64-unknown-elf
 
-GCC_VERSION=13
+GCC_VERSION=14
 GCC_PACKAGE=gcc-$(GCC_VERSION)
 
 DEB_SOURCE_VERSION=$(shell dpkg-parsechangelog -S Version)
@@ -32,6 +32,10 @@
 build_dir=build
 
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-format
+ifeq ($(DEB_BUILD_ARCH),mips64el)
+export DEB_CFLAGS_APPEND=-mxgot
+export DEB_CXXFLAGS_APPEND=-mxgot
+endif
 build_flags:=$(shell dpkg-buildflags --export=configure) INHIBIT_LIBC_CFLAGS="-DUSE_TM_CLONE_REGISTRY=0"
 
 target_tools=\

## gcc-riscv64-unknown-elf 17

=== debian/changelog ===
gcc-riscv64-unknown-elf (17) unstable; urgency=medium

  * Fix --disable-libstdcxx configure flag spelling.
  * Add -mlong-jump-table-offsets for m68k target.
  * Post gcc-14 migration upload. Closes: #1086462.
  * Apply Debian patches too.

 -- Keith Packard <keithp@keithp.com>  Sun, 01 Dec 2024 11:55:17 -0800

=== debian/rules ===
--- 
+++ 
@@ -23,7 +23,7 @@
 base_version := $(shell echo $(deb_version) | sed -e 's/\([1-9]\.[0-9]\).*-.*/\1/')
 BUILT_USING := $(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W $(GCC_PACKAGE)-source)
 
-upstream_dir=gcc-$(deb_upstream_version)
+upstream_dir=src
 
 unpack_stamp=$(stampdir)/unpack
 tar_stamp=$(stampdir)/tar
@@ -35,6 +35,10 @@
 ifeq ($(DEB_BUILD_ARCH),mips64el)
 export DEB_CFLAGS_APPEND=-mxgot
 export DEB_CXXFLAGS_APPEND=-mxgot
+endif
+ifeq ($(DEB_BUILD_ARCH),m68k)
+export DEB_CFLAGS_APPEND=-mlong-jump-table-offsets
+export DEB_CXXFLAGS_APPEND=-mlong-jump-table-offsets
 endif
 build_flags:=$(shell dpkg-buildflags --export=configure) INHIBIT_LIBC_CFLAGS="-DUSE_TM_CLONE_REGISTRY=0"
 
@@ -74,7 +78,7 @@
 	--disable-libquadmath \
 	--disable-libssp \
 	--disable-libstdcxx-pch \
-	--disable-libstdc++-v3 \
+	--disable-libstdcxx \
 	--disable-nls \
 	--disable-shared \
 	--disable-threads \
@@ -99,7 +103,7 @@
 
 $(unpack_stamp): $(tar_stamp)
 	set -ex; \
-		cd gcc-*; \
+		cd $(upstream_dir); \
 		for patch in ../debian/patches/*.patch; do \
 			echo Applying patch "$$patch"; \
 			patch -p1 < "$$patch"; \
@@ -107,7 +111,7 @@
 	touch $@
 
 $(tar_stamp):
-	tar xf $(gcc_dir)/gcc-*.tar.*
+	make -f $(gcc_dir)/debian/rules.source SOURCE_DIR=$(gcc_dir)/ series_file=series patch-source
 	mkdir -p $(stampdir)
 	cp /usr/share/doc/$(GCC_PACKAGE)-source/copyright debian/copyright-gcc
 	touch $@

## gcc-riscv64-unknown-elf 18

=== debian/changelog ===
gcc-riscv64-unknown-elf (18) unstable; urgency=medium

  * Revert "debian: Apply debian-specific patches too". Closes: #1092473.

 -- Keith Packard <keithp@keithp.com>  Wed, 08 Jan 2025 08:25:09 -0800

=== debian/rules ===
--- 
+++ 
@@ -23,7 +23,7 @@
 base_version := $(shell echo $(deb_version) | sed -e 's/\([1-9]\.[0-9]\).*-.*/\1/')
 BUILT_USING := $(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W $(GCC_PACKAGE)-source)
 
-upstream_dir=src
+upstream_dir=gcc-$(deb_upstream_version)
 
 unpack_stamp=$(stampdir)/unpack
 tar_stamp=$(stampdir)/tar
@@ -103,7 +103,7 @@
 
 $(unpack_stamp): $(tar_stamp)
 	set -ex; \
-		cd $(upstream_dir); \
+		cd gcc-*; \
 		for patch in ../debian/patches/*.patch; do \
 			echo Applying patch "$$patch"; \
 			patch -p1 < "$$patch"; \
@@ -111,7 +111,7 @@
 	touch $@
 
 $(tar_stamp):
-	make -f $(gcc_dir)/debian/rules.source SOURCE_DIR=$(gcc_dir)/ series_file=series patch-source
+	tar xf $(gcc_dir)/gcc-*.tar.*
 	mkdir -p $(stampdir)
 	cp /usr/share/doc/$(GCC_PACKAGE)-source/copyright debian/copyright-gcc
 	touch $@

## gcc-riscv64-unknown-elf 19

=== debian/changelog ===
gcc-riscv64-unknown-elf (19) unstable; urgency=medium

  * Use local copy of gcc source code.

 -- Keith Packard <keithp@keithp.com>  Fri, 31 Jan 2025 22:42:54 -0800

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,6 @@
  dejagnu,
  flex,
  gawk,
- gcc-14-source,
  gettext,
  libgmp-dev,
  libmpc-dev,
@@ -35,6 +34,5 @@
 Package: gcc-riscv64-unknown-elf
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}, binutils-riscv64-unknown-elf (>= 2.38.90)
-Built-Using: ${Built-Using}
 Description: GCC cross compiler for Risc-V processors
  Bare metal compiler for embedded Risc-V chips, both 32-bit and 64-bit

=== debian/rules ===
--- 
+++ 
@@ -5,25 +5,23 @@
 
 target=riscv64-unknown-elf
 
-GCC_VERSION=14
-GCC_PACKAGE=gcc-$(GCC_VERSION)
+GCC_VERSION=14.2.0
 
 DEB_SOURCE_VERSION=$(shell dpkg-parsechangelog -S Version)
 
 package=gcc-riscv64-unknown-elf
 top_dir=$(shell pwd)
-gcc_dir=/usr/src/$(GCC_PACKAGE)
+gcc_dir=debian
 doc_dir=/usr/share/doc/$(package)
 build_doc_dir=$(top_dir)/debian/$(package)$(doc_dir)
 stampdir=debian/stamp
 
-source_version := $(shell dpkg-query -W -f="\$${Version}\n" $(GCC_PACKAGE)-source)
+source_version := $(GCC_VERSION)
 deb_version := $(source_version)+$(DEB_SOURCE_VERSION)
-deb_upstream_version := $(shell echo $(deb_version) | cut -d- -f1)
+deb_upstream_version := $(GCC_VERSION)
 base_version := $(shell echo $(deb_version) | sed -e 's/\([1-9]\.[0-9]\).*-.*/\1/')
-BUILT_USING := $(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W $(GCC_PACKAGE)-source)
 
-upstream_dir=gcc-$(deb_upstream_version)
+upstream_dir=gcc-$(GCC_VERSION)
 
 unpack_stamp=$(stampdir)/unpack
 tar_stamp=$(stampdir)/tar
@@ -33,12 +31,12 @@
 
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-format
 ifeq ($(DEB_BUILD_ARCH),mips64el)
-export DEB_CFLAGS_APPEND=-mxgot
-export DEB_CXXFLAGS_APPEND=-mxgot
+export DEB_CFLAGS_MAINT_APPEND=-mxgot
+export DEB_CXXFLAGS_MAINT_APPEND=-mxgot
 endif
 ifeq ($(DEB_BUILD_ARCH),m68k)
-export DEB_CFLAGS_APPEND=-mlong-jump-table-offsets
-export DEB_CXXFLAGS_APPEND=-mlong-jump-table-offsets
+export DEB_CFLAGS_MAINT_APPEND=-mlong-jump-table-offsets
+export DEB_CXXFLAGS_MAINT_APPEND=-mlong-jump-table-offsets
 endif
 build_flags:=$(shell dpkg-buildflags --export=configure) INHIBIT_LIBC_CFLAGS="-DUSE_TM_CLONE_REGISTRY=0"
 
@@ -113,7 +111,6 @@
 $(tar_stamp):
 	tar xf $(gcc_dir)/gcc-*.tar.*
 	mkdir -p $(stampdir)
-	cp /usr/share/doc/$(GCC_PACKAGE)-source/copyright debian/copyright-gcc
 	touch $@
 
 override_dh_autoreconf: $(unpack_stamp)
@@ -124,7 +121,7 @@
 	dh_auto_configure -D$(src_dir) -B$(build_dir) -- $(configure_flags)
 
 override_dh_auto_clean:
-	rm -rf $(upstream_dir) $(build_dir) debian/tmp debian/copyright-gcc $(stampdir)
+	rm -rf $(upstream_dir) $(build_dir) debian/tmp $(stampdir)
 	dh_autoreconf_clean
 
 override_dh_auto_test:
@@ -132,7 +129,7 @@
 #	dh_auto_test -D$(src_dir) -B$(build_dir) --max-parallel=1
 
 override_dh_gencontrol:
-	dh_gencontrol -a -- -v$(deb_version) -Vlocal:Version=$(deb_upstream_version) -Vgcc:Version=$(source_version) -VBuilt-Using="$(BUILT_USING)"
+	dh_gencontrol -a -- -v$(deb_version) -Vlocal:Version=$(deb_upstream_version) -Vgcc:Version=$(source_version)
 
 override_dh_auto_install:
 	mkdir -p $(top_dir)/debian/tmp

## gcc-riscv64-unknown-elf 20

=== debian/changelog ===
gcc-riscv64-unknown-elf (20) unstable; urgency=medium

  * Support cross building.

 -- Keith Packard <keithp@keithp.com>  Fri, 05 Sep 2025 13:21:30 -0700

=== debian/control ===
--- 
+++ 
@@ -33,6 +33,7 @@
 
 Package: gcc-riscv64-unknown-elf
 Architecture: any
+Multi-Arch: foreign
 Depends: ${misc:Depends}, ${shlibs:Depends}, binutils-riscv64-unknown-elf (>= 2.38.90)
 Description: GCC cross compiler for Risc-V processors
  Bare metal compiler for embedded Risc-V chips, both 32-bit and 64-bit

## gcc-riscv64-unknown-elf 23

=== debian/changelog ===
gcc-riscv64-unknown-elf (23) unstable; urgency=medium

  * Update to latest binutils with new paths

  * Add multilib-space and picolibc compiler patches

  * Add source package gcc-riscv64-unknown-elf-source for libstdc++
  
 -- Keith Packard <keithp@keithp.com>  Thu, 22 Jan 2026 16:53:48 -0800

gcc-riscv64-unknown-elf (22) unstable; urgency=medium

  * Change default for -fzero-init-padding-bits to 'all'

 -- Keith Packard <keithp@keithp.com>  Fri, 26 Sep 2025 10:00:45 -0700

gcc-riscv64-unknown-elf (21) unstable; urgency=medium

  * Update to GCC version 15.2.0

 -- Keith Packard <keithp@keithp.com>  Mon, 08 Sep 2025 22:13:36 -0700

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Keith Packard <keithp@keithp.com>
 Build-Depends:
  autoconf2.69,
- binutils-riscv64-unknown-elf (>= 2.38.90),
+ binutils-riscv64-unknown-elf (>= 2.45.50.20260019),
  bison,
  debhelper (>= 10),
  dejagnu,
@@ -34,6 +34,17 @@
 Package: gcc-riscv64-unknown-elf
 Architecture: any
 Multi-Arch: foreign
-Depends: ${misc:Depends}, ${shlibs:Depends}, binutils-riscv64-unknown-elf (>= 2.38.90)
+Depends: ${misc:Depends}, ${shlibs:Depends}, binutils-riscv64-unknown-elf (>= 2.45.50.20260019)
+Recommends: picolibc-riscv64-unknown-elf
 Description: GCC cross compiler for Risc-V processors
  Bare metal compiler for embedded Risc-V chips, both 32-bit and 64-bit
+
+Package: gcc-riscv64-unknown-elf-source
+Architecture: all
+Multi-Arch: foreign
+Depends: ${misc:Depends}
+Description: GCC cross compiler for Risc-V  processors (source)
+ Bare metal compiler for embedded Risc-V chips, both 32-bit and 64-bit
+ .
+ This package contains the sources and patches which are needed
+ to build the GNU Compiler Collection (GCC) for Risc-V processors.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

GCC_VERSION=15.2.0
DEB_SOURCE_VERSION=$(shell dpkg-parsechangelog -S Version)
DEB_VERSION := $(GCC_VERSION)-$(DEB_SOURCE_VERSION)

PACKAGE_GCC_RISCV=gcc-riscv64-unknown-elf
PACKAGE_GCC_SOURCE=gcc-riscv64-unknown-elf-source
TARGET_RISCV=riscv64-unknown-elf
TOP_DIR=$(shell pwd)
NPROC=$(shell nproc)

GCC_TAR_DIR=debian
GCC_BUILD_DIR_RISCV=$(TOP_DIR)/build-$(TARGET_RISCV)
GCC_SOURCE_DIR=gcc-$(GCC_VERSION)
GCC_DEB_TMP_DIR_RISCV=$(TOP_DIR)/debian/$(PACKAGE_GCC_RISCV)-tmp
GCC_SOURCE_DEB_TMP_DIR=$(TOP_DIR)/debian/$(PACKAGE_GCC_SOURCE)-tmp

export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-format
ifeq ($(DEB_BUILD_ARCH),mips64el)
export DEB_CFLAGS_MAINT_APPEND=-mxgot
export DEB_CXXFLAGS_MAINT_APPEND=-mxgot
endif
ifeq ($(DEB_BUILD_ARCH),m68k)
export DEB_CFLAGS_MAINT_APPEND=-mlong-jump-table-offsets
export DEB_CXXFLAGS_MAINT_APPEND=-mlong-jump-table-offsets
endif

BUILDFLAGS:=$(shell dpkg-buildflags --export=configure) INHIBIT_LIBC_CFLAGS="-DUSE_TM_CLONE_REGISTRY=0"

STAMPDIR=debian/stamp

unpack_stamp=$(STAMPDIR)/unpack
tar_stamp=$(STAMPDIR)/tar

TARGET_TOOLS_RISCV=\
	AR_FOR_TARGET=$(TARGET_RISCV)-ar \
	AS_FOR_TARGET=$(TARGET_RISCV)-as \
	LD_FOR_TARGET=$(TARGET_RISCV)-ld \
	NM_FOR_TARGET=$(TARGET_RISCV)-nm \
	OBJDUMP_FOR_TARGET=$(TARGET_RISCV)-objdump \
	RANLIB_FOR_TARGET=$(TARGET_RISCV)-ranlib \
	READELF_FOR_TARGET=$(TARGET_RISCV)-readelf \
	STRIP_FOR_TARGET=$(TARGET_RISCV)-strip

CONFIGURE_GCC_FLAGS_LIBSTDC = \
	--disable-libstdcxx

CONFIGURE_GCC_FLAGS_COMMON = \
	--with-gcc-major-version-only \
	--mandir=/usr/share/man \
	--enable-languages=c,c++,lto \
	--enable-multilib-space \
	--disable-decimal-float \
	--disable-libffi \
	--disable-libgomp \
	--disable-libmudflap \
	--disable-libquadmath \
	--disable-libssp \
	--disable-libstdcxx-pch \
	--disable-nls \
	--disable-shared \
	--disable-threads \
	--enable-tls \
	--build=$(DEB_BUILD_GNU_TYPE) \
	--with-system-zlib \
	--with-gnu-as \
	--with-gnu-ld \
	"--with-pkgversion=$(DEB_VERSION)" \
	--without-included-gettext \
	--prefix=/usr \
	--libexecdir=/usr/libexec \
	--libdir=/usr/lib \
	--host=$(DEB_HOST_GNU_TYPE) \
	--with-headers=no \
	--with-picolibc \
	--without-newlib \
	$(CONFIGURE_GCC_FLAGS_LIBSTDC) \
	$(BUILDFLAGS) \
	SED=/bin/sed \
	SHELL=/bin/sh \
	BASH=/bin/bash \
	CONFIG_SHELL=/bin/bash

CONFIGURE_GCC_FLAGS_RISCV = \
	$(CONFIGURE_GCC_FLAGS_COMMON) \
	--target=$(TARGET_RISCV) \
	--enable-multilib \
	--includedir=/usr/$(TARGET_RISCV)/include \
	--infodir=/usr/share/doc/$(PACKAGE_GCC_RISCV)/info \
	--htmldir=/usr/share/doc/$(PACKAGE_GCC_RISCV)/html \
	--pdfdir=/usr/share/doc/$(PACKAGE_GCC_RISCV)/pdf \
	--with-cmodel=medany \
	--with-arch=rv64imafdc \
	$(TARGET_TOOLS_RISCV)

%:
	dh $@ --parallel --with autoreconf

$(unpack_stamp): $(tar_stamp)
	set -ex; \
		cd gcc-*; \
		for patch in ../debian/patches/*.patch; do \
			echo Applying patch "$$patch"; \
			patch -p1 < "$$patch"; \
		done
	touch $@

$(tar_stamp):
	tar xf $(GCC_TAR_DIR)/gcc-*.tar.*
	mkdir -p $(STAMPDIR)
	touch $@

override_dh_autoreconf: $(unpack_stamp)
	autoreconf2.69 -f -i $(GCC_SOURCE_DIR)

override_dh_auto_configure: $(unpack_stamp)
	dh_auto_configure -D$(GCC_SOURCE_DIR) -Bbuild-$(TARGET_RISCV) -- $(CONFIGURE_GCC_FLAGS_RISCV)

override_dh_auto_build:
	dh_auto_build -Bbuild-$(TARGET_RISCV) -- -j$(NPROC)

override_dh_auto_install:
	$(MAKE) install -C$(GCC_BUILD_DIR_RISCV) DESTDIR=$(GCC_DEB_TMP_DIR_RISCV)

override_dh_auto_test:
	@echo "no testing, that's way too painful"

override_dh_clean:
	rm -rf $(GCC_BUILD_DIR_RISCV)
	rm -rf $(GCC_DEB_TMP_DIR_RISCV)
	rm -rf $(GCC_SOURCE_DEB_TMP_DIR)
	rm -rf $(GCC_SOURCE_DIR)
	rm -rf $(STAMPDIR)
	dh_clean

override_dh_strip:
	dh_strip -X.a

override_dh_install:
	dh_install -p$(PACKAGE_GCC_RISCV) --sourcedir $(GCC_DEB_TMP_DIR_RISCV)
	mkdir -p $(GCC_SOURCE_DEB_TMP_DIR)/usr/src
	tar --exclude=autom4te.cache --sort=name --mtime="@$(SOURCE_DATE_EPOCH)" --owner=0 --group=0 --numeric-owner --mode=go-w,u+rw -C $(GCC_SOURCE_DIR) -c -f - . | xz -T0 > $(GCC_SOURCE_DEB_TMP_DIR)/usr/src/$(PACKAGE_GCC_SOURCE).tar.xz
	dh_install -p$(PACKAGE_GCC_SOURCE) --sourcedir $(GCC_SOURCE_DEB_TMP_DIR)

override_dh_compress:
	dh_compress -Xexamples/

override_dh_installchangelogs:
	dh_installchangelogs $(GCC_SOURCE_DIR)/ChangeLog

override_dh_gencontrol:
	dh_gencontrol -- -v$(DEB_VERSION) -Vgcc:Version=$(GCC_VERSION)
